#pragma once

#define INITGUID

#define VC_EXTRALEAN
#define _WIN32_WINNT 0x0501			// Windows XP.

#include <windows.h>

// STL.

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <fstream>
#include <sstream>

using namespace std;

// OpenGL

#include <gl\gl.h>
#include <gl\glu.h>

// Std

#define _USE_MATH_DEFINES

#include <math.h>

///* Local //*/

#include "vector3.h"

// Resources.

#include "resource.h"

// Useful string functions

template <typename T> string ToString(T value)
{
	string result;
	
	stringstream stream;

	stream.precision(5);
	stream.setf(ios::fixed);

	stream << value;

	stream >> result;

	return result;
}

template <typename T> T ParseString(string s)
{
	T result;
	
	stringstream stream;

	stream.precision(5);

	stream << s;

	stream >> result;

	if(stream.fail()) return 0.0;	// Couldnt interpret result.

	return result;
}