#pragma once

#include "base.h"

/*

The camera class is responsible for updating its own position based on keyboard and mouse data.
From this information it also calculates a forward vector used in combination with its position
to transform the model-view matrix using the gluLookAt function.

*/

class Camera
{
	float	cameraTheta;		// Yaw
	float	cameraPhi;			// Pitch

	Vector3	cameraPosition;
	Vector3	cameraForward;

	bool captureInput;
	bool updateVectors;

	//

	int oldCursorX, oldCursorY;

public:

	Camera();

	~Camera();

	void LookAt(Vector3 Eye, Vector3 At, Vector3 Up);

	bool keyDown(BYTE key);

	void update();

	bool& UpdateVectors();

	void render(int x=0, int y=0);	// Supply xy data for pick.

	Vector3 ComputeForward();

	Vector3& Forward();

	Vector3& Position();

	void setCapture(bool capture = true);

	void capture();

	void release();

	bool captured();
};