#pragma once

#include "base.h"

#include "globject.h"

struct UV
{
	float u;
	float v;
};

struct TLVertex : public UV, public Vector3
{
	Vector3 norm;
};

/*

The Mesh class extends the functionality of the GLObject and includes a method to allow the
loading and rendering of .OFF formated meshes.

*/

class Mesh : public GLObject
{
	vector<TLVertex>	vertices;
	vector<int>			indices;		// Indices into vertex list.

	GLuint				m_Texture;

public:

	Mesh();

	Mesh(Vector3 v);

	virtual void Destroy();

	void DestroyTexture();

	bool LoadTexture(string Path);
	
	bool LoadOFF(string path);	// OFF object loader.

	virtual void Render();
};