#pragma once

#include "mainwindow.h"

/*

This class extends the functionality of the MainWindow class, and responds to resizing and
paint events. It allows OpenGL initialization using it's device handle as a basis.

*/

class OpenGLWindow : public MainWindow
{
private:

	HGLRC m_hRC;

public:

	OpenGLWindow();

	BOOL InitOpenGL(BYTE BitDepth = 32);

	void ResetViewport(int Width, int Height);		// Used for when the window is resized.

	void SwapBuffers();

private:

	BOOL InitStates();

	//

	virtual void SizeEvent(int width, int height);
	virtual void PaintEvent(HDC paintDC);
};